Differences between revisions 79 and 119 (spanning 40 versions)
Revision 79 as of 2013-12-11 22:14:48
Size: 8324
Editor: 188-223-3-27
Comment: There's no getopts implementation where `-:` works to allow long options.
Revision 119 as of 2024-02-26 07:51:38
Size: 8323
Editor: larryv
Comment: replaced bash-hackers URL with Wayback Machine version
Deletions are marked like this. Additions are marked like this.
Line 1: Line 1:
#pragma section-numbers 3
Line 3: Line 2:
== How can I handle command-line arguments (options) to my script easily? ==
Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.
== How can I handle command-line options and arguments in my script easily? ==
Well, that depends a great deal on what you want to do with them. There are two standard approaches, each with its strengths and weaknesses.
Line 8: Line 7:
=== Overview ===
A Unix command generally has an argument syntax like this:

{{{
tar -x -f archive.tar -v -- file1 file2 file3
}}}
Please note the conventions and the ordering here, because they are ''important''. They actually matter. This command has some ''arguments'' (file1, file2, file3), and some ''options'' (-x -f archive.tar -v), as well as the traditional ''end of options indicator'' "--".

The options appear ''before'' the non-option arguments. They do not appear afterward. They do not appear at just any old random place in the command.

Some options (-x, -v) are standalones. They are either present, or not. Some options (-f) take an ''argument'' of their own.

In all cases, option processing involves writing a loop. Ideally, this loop will make ''one pass'' over the argument list, examining each argument in turn, and setting appropriate shell variables so that the script remembers which options are in effect. Ultimately, it will ''discard'' all of the options, so that the argument list is left holding only the ''non-option arguments'' (file1 file2 file3). The rest of the script, then, can simply begin processing those, referring as needed to the variables that were set up by the option processor.

The option processor recognizes the end of options when it finds a -- argument, or when it finds an argument that doesn't start with a hyphen. (The ''option argument'' archive.tar does not signal the end of options, because it is processed along with the -f option.)

There are two basic approaches to writing an option processing loop: either write the loop yourself from scratch (we'll call this a "manual loop"), or use the shell's `getopts` command to assist with option splitting. We'll cover both of these cases.

'''Do not use getopt(1). Do not even discuss getopt on this page.''' Go to ComplexOptionParsing to learn more about it.
Line 9: Line 28:
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this is the simplest approach (because you rarely need fancy stuff). Manually parsing options is the most flexible approach. It is the ''best'' way, really, because it allows you to do anything you like: you can handle both single-letter and long options, with or without option arguments. That's why we're showing it first.
Line 11: Line 30:
This example will handle a combination of short and long options. Notice how both "--file" and "--file=FILE" are handled. If you want to handle GNU-style `--long-options` or Tcl-style `-longopts`, a manual loop is your only choice. `getopts` does not support these.

In this example, notice how both `--file FILE` and `--file=FILE` are handled.
Line 15: Line 36:
# (POSIX shell syntax) # POSIX
Line 17: Line 38:
# Reset all variables that might be set
file=""
die() {
    printf '%s\n' "$1" >&2
    exit 1
}

# Initialize all the option variables.
# This ensures we are not contaminated by variables from the environment.
file=
Line 21: Line 48:
while :
do
while :; do
Line 24: Line 50:
        -h | --help | -\?)
            # Call your Help() or usage() function here.
            exit 0 # This is not an error, User asked help. Don't do "exit 1"
        -h|-\?|--help)
            show_help # Display a usage synopsis.
            exit
Line 28: Line 54:
        -f | --file)
            file=$2 # You might want to check if you really got FILE
            shift 2
        -f|--file) # Takes an option argument; ensure it has been specified.
            if [ "$2" ]; then
                file=$2
                shift
            else
                die 'ERROR: "--file" requires a non-empty option argument.'
            fi
Line 32: Line 62:
        --file=*)
            file=${1#*=}        # Delete everything up till "="
        shift
        --file=?*)
            file=${1#*=} # Delete everything up to "=" and assign the remainder.
Line 36: Line 65:
        -v | --verbose)
            # Each instance of -v adds 1 to verbosity
            verbose=$((verbose+1))
            shift
        --file=) # Handle the case of an empty --file=
            die 'ERROR: "--file" requires a non-empty option argument.'
Line 41: Line 68:
        --) # End of all options         -v|--verbose)
            verbose=$((verbose + 1)) # Each -v adds 1 to verbosity.
            ;;
        --) # End of all options.
Line 45: Line 75:
        -*)
            echo "WARN: Unknown option (ignored): $1" >&2
            shift
        -?*)
            printf 'WARN: Unknown option (ignored): %s\n' "$1" >&2
Line 49: Line 78:
        *) # no more options. Stop while loop         *)              # Default case: No more options, so break out of the loop.
Line 51: Line 80:
            ;;
Line 53: Line 81:

    shift
Line 55: Line 85:
# Suppose some options are required. Check that we got them.

if [ ! "$file" ]; then
    echo "ERROR: option '--file FILE' not given. See --help" >&2
    exit 1
# if --file was provided, open it for writing, else duplicate stdout
if [ "$file" ]; then
    exec 3> "$file"
else
    exec 3>&1
Line 66: Line 96:
This parser does not handle separate options concatenated together (like `-xvf` being understood as `-x -v -f`). This could be added with effort, but this is left as an exercise for the reader. This parser does not handle single-letter options concatenated together (like `-xvf` being understood as `-x -v -f`). This could be added with effort, but it's left as an exercise for the reader.  In practice, it's exceptionally rare for shell scripts that handle long options to handle single-letter option splitting as well. It's simply not worth the effort.
Line 68: Line 98:
Some Bash programmers like to write this at the beginning of their scripts to guard against unused variables:

{{{
    set -u # or, set -o nounset
}}}
The use of this breaks the loop above, as "$1" may not be set upon entering the loop. There are four solutions to this issue:

 1. Stop using `-u`.
 1. Replace `case $1 in` with `case ${1+$1} in` (as well as bandaging all the other code that `set -u` breaks).
 1. Replace `case $1 in` with `case ${1-} in` (every potentially undeclared variable could be written as ${variable-} to prevent `set -u` tripping).
 1. Stop using `-u`.
For the most part, shell scripts that you write will not need to worry about single-letter option splitting, because you are the only person using them. Fancy option processing is only desirable if you are releasing the program for general use, and that is almost ''never'' going to be the case in real life. Single-letter option combining also precludes the use of Tcl-style long arguments (`-foo`), which some commands like [[https://pubs.opengroup.org/onlinepubs/9699919799/utilities/find.html|find(1)]], [[https://linux.die.net/man/1/gcc|gcc(1)]] and [[https://linux.die.net/man/1/star|star(1)]] use.
Line 81: Line 101:
Unless it's the version from util-linux, and use its advanced mode, '''never use getopt(1).''' Traditional versions of `getopt` cannot handle empty arguments strings, or arguments with embedded whitespace. The main benefit of `getopts` is to allow single-letter option splitting (`-xvf` handled as `-x -v -f`). The trade-off for this is that you cannot use long arguments of any kind (GNU-style `--foo` or Tcl-style `-foo`), or options with an optional argument (like `mysql`'s `-p[password]` option).
Line 83: Line 103:
The POSIX shell (and others) offer `getopts` which is safe to use instead. Here is a simplistic `getopts` example: `getopts` is suitable for simple scripts. The more complex your option parsing needs are, the less likely it is that you'll be able to make use of `getopts`.

Here is a `getopts` example:
Line 87: Line 109:

# Usage info
show_help() {
cat << EOF
Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]...
Do stuff with FILE and write the result to standard output. With no FILE
or when FILE is -, read standard input.

    -h display this help and exit
    -f OUTFILE write the result to OUTFILE instead of standard output.
    -v verbose mode. Can be used multiple times for increased
                verbosity.
EOF
}
Line 92: Line 128:
OPTIND=1 # Reset is necessary if getopts was used previously in the script.  It is a good idea to make this local in a function.
while getopts "hvf:" opt; do
    case "$opt" in
OPTIND=1
# Resetting OPTIND is necessary if getopts was used previously in the script.
#
It is a good idea to make OPTIND local if you process options in a function.

while getopts hvf: opt; do
    case $opt in
Line 99: Line 138:
        v) verbose=1         v) verbose=$((verbose+1))
Line 103: Line 142:
        *)
            show_help >&2
            exit 1
            ;;
Line 105: Line 148:
shift $((OPTIND-1)) # Shift off the options and optional --. shift "$((OPTIND-1))" # Discard the options and sentinel --
Line 107: Line 150:
echo "verbose=$verbose, output_file='$output_file', Leftovers: $@" # Everything that's left in "$@" is a non-option. In our case, a FILE to process.
printf 'verbose=<%d>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file"
printf '<%s>\n' "$@"
Line 111: Line 156:
The advantages of `getopts` are: There is a [[https://web.archive.org/web/20230324055145/https://wiki.bash-hackers.org/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. In bash, there is also `help getopts`.
Line 113: Line 158:
 1. It's portable, and will work in e.g. dash.
 1. It can handle things like `-vf filename` in the expected Unix way, automatically.
The advantages of `getopts` over a manual loop:
Line 116: Line 160:
The disadvantage of `getopts` is that (except on `ksh93`), it can only handle short options (`-h`, not `--help`) without trickery.  1. It can handle things like `-xvf filename` in the expected Unix way, automatically.
 1. It makes sure options are parsed like any standard command (lowest common denominator), avoiding surprises.
 1. With some implementations, the error messages will be localised in the language of the user.
Line 118: Line 164:
There is a [[http://wiki.bash-hackers.org/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. In bash, there is also `help getopts`, which might be informative. The disadvantages of `getopts`:
Line 120: Line 166:
There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all.  1. (Except for ksh93) it can only handle short options (`-h`, not `--help`).
 1. It cannot handle options with optional arguments like `mysql`'s `-p[password]`.
 1. It doesn't exist in the Bourne shell.
 1. It ''only'' allows options to be parsed in the "standard way" (lowest common denominator).
 1. Options are coded in at least 2, probably 3 places -- in the call to `getopts`, in the case statement that processes them, and in the help/usage message that documents them.
Line 122: Line 172:
`?`, `:`, and `-` are the 3 characters that are not allowed as option names by `getopts`.

=== Silly repeated brute-force scanning ===
Another approach is to check options with `if` statements "on demand". A function like this one may be useful:

{{{#!highlight bash
#!/bin/bash

HaveOpt ()
{
    local needle=$1
    shift

    while [[ $1 == -* ]]
    do
        # By convention, "--" means end of options.
        case "$1" in
            --) return 1 ;;
            $needle) return 0 ;;
        esac

        shift
    done

    return 1
}

HaveOpt --quick "$@" && echo "Option quick is set"

# End of file
}}}
and it will work if script is run as:

 * YES: ./script --quick
 * YES: ./script -other --quick

but will stop on first argument with no "-" in front (or on --):

 * NO: ./script -bar foo --quick
 * NO: ./script -bar -- --quick

Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables.

It also spreads the options throughout the program. The literal option `--quick` may appear a hundred lines down inside the main body of the program, nowhere near any other option name. This is a nightmare for maintenance.

=== Complex nonstandard add-on utilities ===
[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] suggests the use of [[http://sourceforge.net/projects/process-getopt/|process-getopt]] (GPL licensed) and offers this example code:

{{{
PROG=$(basename $0)
VERSION='1.2'
USAGE="A tiny example using process-getopt(1)"

# call process-getopt functions to define some options:
source process-getopt

SLOT=""
SLOT_func() { [ "${1:-""}" ] && SLOT="yes"; } # callback for SLOT option
add_opt SLOT "boolean option" s "" slot

TOKEN=""
TOKEN_func() { [ "${1:-""}" ] && TOKEN="$2"; } # callback for TOKEN option
add_opt TOKEN "this option takes a value" t n token number

add_std_opts # define the standard options --help etc:

TEMP=$(call_getopt "$@") || exit 1
eval set -- "$TEMP" # just as with getopt(1)

# remove the options from the command line
process_opts "$@" || shift "$?"

echo "SLOT=$SLOT"
echo "TOKEN=$TOKEN"
echo "args=$@"
}}}
Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you.

 . ''Actually, what the author forgot to say was that it's actually using `getopts` semantics, rather than `getopt`. I ran this test:''
 {{{
 ~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'"
 ~/process-getopt-1.6$ call_getopt "$@"
  -- 'rm -rf /' 'foo;bar' ''\'''
}}}
 . ''It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the [[BashFAQ/048|eval]] not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat ''

''It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for {{{getopt --test}}}) it only processes short options. It does not use the bash builtin getopts(1) command. -[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] ''
For other, more complicated ways of option parsing, see ComplexOptionParsing.
Line 211: Line 175:
'' CategoryShell '' CategoryShell

How can I handle command-line options and arguments in my script easily?

Well, that depends a great deal on what you want to do with them. There are two standard approaches, each with its strengths and weaknesses.

Overview

A Unix command generally has an argument syntax like this:

tar -x -f archive.tar -v -- file1 file2 file3

Please note the conventions and the ordering here, because they are important. They actually matter. This command has some arguments (file1, file2, file3), and some options (-x -f archive.tar -v), as well as the traditional end of options indicator "--".

The options appear before the non-option arguments. They do not appear afterward. They do not appear at just any old random place in the command.

Some options (-x, -v) are standalones. They are either present, or not. Some options (-f) take an argument of their own.

In all cases, option processing involves writing a loop. Ideally, this loop will make one pass over the argument list, examining each argument in turn, and setting appropriate shell variables so that the script remembers which options are in effect. Ultimately, it will discard all of the options, so that the argument list is left holding only the non-option arguments (file1 file2 file3). The rest of the script, then, can simply begin processing those, referring as needed to the variables that were set up by the option processor.

The option processor recognizes the end of options when it finds a -- argument, or when it finds an argument that doesn't start with a hyphen. (The option argument archive.tar does not signal the end of options, because it is processed along with the -f option.)

There are two basic approaches to writing an option processing loop: either write the loop yourself from scratch (we'll call this a "manual loop"), or use the shell's getopts command to assist with option splitting. We'll cover both of these cases.

Do not use getopt(1). Do not even discuss getopt on this page. Go to ComplexOptionParsing to learn more about it.

Manual loop

Manually parsing options is the most flexible approach. It is the best way, really, because it allows you to do anything you like: you can handle both single-letter and long options, with or without option arguments. That's why we're showing it first.

If you want to handle GNU-style --long-options or Tcl-style -longopts, a manual loop is your only choice. getopts does not support these.

In this example, notice how both --file FILE and --file=FILE are handled.

   1 #!/bin/sh
   2 # POSIX
   3 
   4 die() {
   5     printf '%s\n' "$1" >&2
   6     exit 1
   7 }
   8 
   9 # Initialize all the option variables.
  10 # This ensures we are not contaminated by variables from the environment.
  11 file=
  12 verbose=0
  13 
  14 while :; do
  15     case $1 in
  16         -h|-\?|--help)
  17             show_help    # Display a usage synopsis.
  18             exit
  19             ;;
  20         -f|--file)       # Takes an option argument; ensure it has been specified.
  21             if [ "$2" ]; then
  22                 file=$2
  23                 shift
  24             else
  25                 die 'ERROR: "--file" requires a non-empty option argument.'
  26             fi
  27             ;;
  28         --file=?*)
  29             file=${1#*=} # Delete everything up to "=" and assign the remainder.
  30             ;;
  31         --file=)         # Handle the case of an empty --file=
  32             die 'ERROR: "--file" requires a non-empty option argument.'
  33             ;;
  34         -v|--verbose)
  35             verbose=$((verbose + 1))  # Each -v adds 1 to verbosity.
  36             ;;
  37         --)              # End of all options.
  38             shift
  39             break
  40             ;;
  41         -?*)
  42             printf 'WARN: Unknown option (ignored): %s\n' "$1" >&2
  43             ;;
  44         *)               # Default case: No more options, so break out of the loop.
  45             break
  46     esac
  47 
  48     shift
  49 done
  50 
  51 # if --file was provided, open it for writing, else duplicate stdout
  52 if [ "$file" ]; then
  53     exec 3> "$file"
  54 else
  55     exec 3>&1
  56 fi
  57 
  58 # Rest of the program here.
  59 # If there are input files (for example) that follow the options, they
  60 # will remain in the "$@" positional parameters.

This parser does not handle single-letter options concatenated together (like -xvf being understood as -x -v -f). This could be added with effort, but it's left as an exercise for the reader. In practice, it's exceptionally rare for shell scripts that handle long options to handle single-letter option splitting as well. It's simply not worth the effort.

For the most part, shell scripts that you write will not need to worry about single-letter option splitting, because you are the only person using them. Fancy option processing is only desirable if you are releasing the program for general use, and that is almost never going to be the case in real life. Single-letter option combining also precludes the use of Tcl-style long arguments (-foo), which some commands like find(1), gcc(1) and star(1) use.

getopts

The main benefit of getopts is to allow single-letter option splitting (-xvf handled as -x -v -f). The trade-off for this is that you cannot use long arguments of any kind (GNU-style --foo or Tcl-style -foo), or options with an optional argument (like mysql's -p[password] option).

getopts is suitable for simple scripts. The more complex your option parsing needs are, the less likely it is that you'll be able to make use of getopts.

Here is a getopts example:

   1 #!/bin/sh
   2 
   3 # Usage info
   4 show_help() {
   5 cat << EOF
   6 Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]...
   7 Do stuff with FILE and write the result to standard output. With no FILE
   8 or when FILE is -, read standard input.
   9 
  10     -h          display this help and exit
  11     -f OUTFILE  write the result to OUTFILE instead of standard output.
  12     -v          verbose mode. Can be used multiple times for increased
  13                 verbosity.
  14 EOF
  15 }
  16 
  17 # Initialize our own variables:
  18 output_file=""
  19 verbose=0
  20 
  21 OPTIND=1
  22 # Resetting OPTIND is necessary if getopts was used previously in the script.
  23 # It is a good idea to make OPTIND local if you process options in a function.
  24 
  25 while getopts hvf: opt; do
  26     case $opt in
  27         h)
  28             show_help
  29             exit 0
  30             ;;
  31         v)  verbose=$((verbose+1))
  32             ;;
  33         f)  output_file=$OPTARG
  34             ;;
  35         *)
  36             show_help >&2
  37             exit 1
  38             ;;
  39     esac
  40 done
  41 shift "$((OPTIND-1))"   # Discard the options and sentinel --
  42 
  43 # Everything that's left in "$@" is a non-option.  In our case, a FILE to process.
  44 printf 'verbose=<%d>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file"
  45 printf '<%s>\n' "$@"
  46 
  47 # End of file

There is a getopts tutorial which explains what all of the syntax and variables mean. In bash, there is also help getopts.

The advantages of getopts over a manual loop:

  1. It can handle things like -xvf filename in the expected Unix way, automatically.

  2. It makes sure options are parsed like any standard command (lowest common denominator), avoiding surprises.
  3. With some implementations, the error messages will be localised in the language of the user.

The disadvantages of getopts:

  1. (Except for ksh93) it can only handle short options (-h, not --help).

  2. It cannot handle options with optional arguments like mysql's -p[password].

  3. It doesn't exist in the Bourne shell.
  4. It only allows options to be parsed in the "standard way" (lowest common denominator).

  5. Options are coded in at least 2, probably 3 places -- in the call to getopts, in the case statement that processes them, and in the help/usage message that documents them.

For other, more complicated ways of option parsing, see ComplexOptionParsing.


CategoryShell

BashFAQ/035 (last edited 2024-02-26 07:51:38 by larryv)